<template>
  <div>
    <div class="top-nav">
      <router-link class="active" to="/">Home</router-link>
      <div class="top-nav-right">
        <router-link to="/signup">Login / Register</router-link>
      </div>
    </div>
    <div class="card-wrapper">
      <div class="card">
        <h3 style="font-weight: bold"> Create an Account </h3>
        <form v-on:submit.prevent="onSubmit" form>
          <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" id="name" placeholder="Your name"
                   v-model="form.name" required>
          </div>
          <div class="form-group">
            <label for="name">Email</label>
            <input type="email" class="form-control" id="email" placeholder="name@example.com"
                   v-model="form.email" required>
          </div>
          <div class="form-group">
            <label for="name">Password</label>
            <input type="password" class="form-control" id="password" placeholder="Your password"
                   v-model="form.password" required>
          </div>
          <div class="form-group">
            <div class="center">
              <button class="btn btn-primary">Sign up</button>
              <br><br><br>
            </div>
            <alert :message=message v-if="showMessage" class="red--text"></alert>
          </div>
        </form>
      </div>
      <div class="card">
        <h3 style="font-weight: bold"> Log in </h3>
        <form v-on:submit.prevent="onLogin" form>
          <div class="form-group">
            <label for="name">Username</label>
            <input type="text" class="form-control" id="username1" placeholder="Username"
                   v-model="formLog.username" required>
          </div>
          <div class="form-group">
            <label for="name">Password</label>
            <input type="password" class="form-control" id="password1" placeholder="Your password"
                   v-model="formLog.password" required>
          </div>
          <div class="form-group">
            <div class="center">
              <button class="btn btn-primary">Log in</button>
              <br><br><br>
            </div>
            <alert :message=messageLog v-if="showMessageLog" class="red--text"></alert>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import Alert from './Alert.vue';

export const SERVER_API_URL = process.env.SERVER_API_URL || '';

axios.defaults.headers.post['Content-Type'] = 'application/json';

export default {
  name: 'Register',
  data() {
    return {
      msg: '',
      form: {
        name: '',
        email: '',
        password: '',
      },
      formLog: {
        username: '',
        password: '',
      },
      message: '',
      messageLog: '',
      showMessage: false,
      showMessageLog: false,
    };
  },
  components: {
    alert: Alert,
  },
  methods: {
    registerUser(payload) {
      const path = `${SERVER_API_URL}/v1.0/register`;
      // const json = JSON.stringify(payload);
      axios.defaults.headers['Content-Type'] = 'application/json';
      axios.post(path, payload)
        .then((res) => {
          if (res.status === 201) {
            // this.$session.start();
            // console.log(this.$session);
            this.$router.push('/signup');
          }
          console.log(res.data);
          console.log(payload);
          // window.location = '/dashboard';
        })
        .catch((error) => {
          console.error(error);
          const code = error.response.status;
          if (code === 400) {
            this.message = 'Email address already in use!';
            this.showMessage = true;
          }
        });
    },
    logUser(payload) {
      const path = `${SERVER_API_URL}/v1.0/authenticate`;
      const json = JSON.stringify(payload);
      axios.post(path, json)
        .then((res) => {
          const token = `Bearer ${res.data.id_token}`;
          localStorage.setItem('user-token', token);
          if (res.status === 200) {
            // this.$router.push('/dashboard');
            window.location = '/dashboard';
          }
        })
        .catch((error) => {
          console.error(error);
          localStorage.removeItem('user-token'); // if the request fails, remove any possible user token
          const code = error.response.status;
          if (code === 400) {
            this.messageLog = 'Invalid username or password!';
            this.showMessageLog = true;
          }
        });
    },
    onSubmit(evt) {
      evt.preventDefault();
      const payload = {
        login: this.form.name,
        email: this.form.email,
        password: this.form.password,
        langKey: 'es',
        activated: true,
      };
      this.registerUser(payload);
    },
    onLogin(evt) {
      evt.preventDefault();
      const payload = {
        username: this.formLog.username,
        password: this.formLog.password,
      };
      this.logUser(payload);
    },
  },
  created() {
  },
};
</script>

<style>
#app {
  margin-top: 0;
}

/* Setup */
:root {
  --black: #000000;
  --almost-black: #263238;
  --white: #ffffff;
  --almost-white: #FBFBFB;
  --grey-light: #CFD8DC;
  --grey: #B0BEC5;
  --grey-medium: #78909C;
  --grey-dark: #455A64;
  --primary: #1E88E5;
  --primary-dark: #1976D2;
  --secondary: #CFD8DC;
  --secondary-dark: #B0BEC5;
  --red: #EF4836;
}

* {
  justify-content: center;
  text-align-all: center;
  margin: auto;
  position: center;
  box-sizing: border-box;
}

body {
  margin: 0;
  font-family: sans-serif;
  font-size: 18px;
  line-height: 28px;
  color: var(--black);
  background: var(--grey-light);
}

/* Typography */
.center {
  text-align: center;
}

h1 {
  font-weight: bold;
  margin: 0.5em 0 1em;
  font-size: 26px;
  line-height: 1.2;
  color: var(--almost-black);
}

h2 {
  font-weight: bold;
  text-align: center;
  margin: 0.5em 0 1em;
  font-size: 14px;
  line-height: 1.2;
  color: #333333;
}

h3 {
  font-weight: bold;
}

p {
  margin: 24px 0;
}

alert {
  color: #EF4836;
}

/* Cards */
.card-wrapper {
  margin: 0 auto;
  padding: 90px 320px;
  flex-wrap: wrap;
  justify-content: center;
  display: flex;
}

.card {
  text-align: left;
  margin: 0 30px 60px;
  padding: 20px 40px;
  width: 460px;
  box-shadow: 0 8px 26px -4px rgba(0,0,0,0.15);
  border-radius: 5px;
  background: var(--white);
}

@media only screen and (max-width: 520px) {
  .card-wrapper {
    padding: 30px 0 0;
  }
}

@media only screen and (max-width: 520px) {
  .card {
    margin: 0 0 30px;
    width: 100%;
    border-radius: 0;
  }
}

/* Forms */
form {
  transition: opacity .15s ease;
  width: 100%;
  margin-top: auto;
}

form.loading {
  pointer-events: none;
  opacity: 0.75;
}

label {
  font-weight: bolder;
  float:left;
  margin: 10px 2px;
  font-size: 14px;
  line-height: 24px;
  letter-spacing: 0;
  color: var(--grey-dark);
  display: block;
}

a {
  font-weight: bolder;
}

.field {
  margin: 0 0 24px;
  padding: 11px 16px 9px;
  width: 100%;
  font-size: 16px;
  line-height: 26px;
  color: var(--almost-black);
  border: 1px solid var(--grey);
  border-radius: 4px;
  box-shadow: inset 0 1px 2px rgba(0,0,0,0.1);
  display: block;
  background: var(--almost-white);
  transition: border-color .15s ease;
}

.field:focus {
  border-color: var(--grey-medium);
  outline: none;
}

.error {
  margin: 0;
  font-size: 16px;
  line-height: 26px;
  text-align: center;
  color: var(--red);
}

.error--hidden {
  display: none;
}

/* Buttons */
.btn {
  position: center;
  text-align: center;
  margin: auto;
  padding: 11px 30px 10px;
  font-size: 14px;
  line-height: 24px;
  text-transform: uppercase;
  letter-spacing: 1px;
  font-weight: 600;
  text-decoration: none;
  color: var(--white);
  border: none;
  border-radius: 4px;
  outline: none;
  cursor: pointer;
  display: inline-block;
  background: var(--primary);
  transition: color .15s ease, background-color .15s ease;
}

.btn:hover {
  background: var(--primary-dark);
}

.btn--secondary {
  color: var(--almost-black);
  background: var(--secondary);
}

.btn--secondary:hover {
  background: var(--secondary-dark);
}

div.center {
  display: inline-block;
}

</style>
